unit UnidadConfiguracionClienteBD;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, inifiles, Grids, DBGrids, DB;

type
  TformConfiguracionClienteBD = class(TForm)
    bGuardar: TButton;
    Panel1: TPanel;
    bCancelar: TButton;
    sb: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    txtIPServidor: TEdit;
    txtPuerto: TEdit;
    txtUsuario: TEdit;
    txtContrasena: TEdit;
    txtBD: TEdit;
    bProbar: TButton;
    txtTabla: TComboBox;
    Label10: TLabel;
    txtProtocolo: TComboBox;
    lInfoProtocolo: TLabel;
    GroupBox2: TGroupBox;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    txtUsuarioServidorBD: TEdit;
    txtContrasenaServidorBD: TEdit;
    bGuardarUsuario: TButton;
    txtNombreCompleto: TEdit;
    StaticText2: TStaticText;
    bOpciones: TButton;
    procedure bCancelarClick(Sender: TObject);
    procedure bGuardarClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure bProbarClick(Sender: TObject);
    procedure bGuardarUsuarioClick(Sender: TObject);
    procedure txtUsuarioServidorBDChange(Sender: TObject);
    procedure txtContrasenaServidorBDChange(Sender: TObject);
    procedure txtNombreCompletoChange(Sender: TObject);
    function guardarDatosBD () : boolean;
    procedure txtProtocoloChange(
  Sender: TObject);
    procedure txtNombreCompletoKeyPress(Sender: TObject; var Key: Char);
    procedure bOpcionesClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    modificadoUsuario : boolean;
    modificadoContrasena : boolean;
    modificadoNombre : boolean;
  public
    { Public declarations }
  end;

var
  formConfiguracionClienteBD: TformConfiguracionClienteBD;

implementation

uses UnidadModuloDatos, UnidadProcedimientos;

{$R *.dfm}

function obtenerMySQLTablas () : TStringList;
var
  lista : TStringList;
begin
  lista := TStringList.Create;
  md.tcConsultaCreacion.Close;
  md.tcConsultaCreacion.SQL.Clear;
  md.tcConsultaCreacion.SQL.Add('SHOW TABLES');
  try
  md.tcConsultaCreacion.Open;
    while not md.tcConsultaCreacion.Eof do
    begin
      lista.Add (md.tcConsultaCreacion.Fields[0].AsString);
      md.tcConsultaCreacion.Next;
    end;
    Result := lista;
  except
    Result := lista;
  end;
end;


function TformConfiguracionClienteBD.guardarDatosBD () : boolean;
begin
  try
    Screen.Cursor := crHourGlass;
    md.tcConsulta.Active := false;
    md.BD.Connected := false;
    md.BD.LoginPrompt := false;
    md.bd.Protocol := txtProtocolo.Text;
    md.BD.HostName := txtIPServidor.Text;
    md.BD.Port := strtoint(txtPuerto.Text);
    md.BD.Database := txtBD.Text;
    md.BD.User := txtUsuario.Text;
    md.BD.Password := txtContrasena.Text;
    md.BD.Connected := true;
    md.tcConsulta.SQL.Clear;
    md.tcConsulta.SQL.Add('SELECT USUARIO, CONTRASENA FROM ' + txtTabla.Text +
        ' WHERE USUARIO = :pUsuario');
    md.tcConsulta.ParamByName('pUsuario').DataType := ftstring;
    md.tcConsulta.ParamByName('pUsuario').Value := AnsiUpperCase (txtUsuarioServidorBD.Text);
    md.tcConsulta.Open;
    if md.tcConsulta.RecordCount > 0 then
    begin
      if desencriptar (md.tcConsulta.FieldByName('CONTRASENA').AsString,
          claveEncriptacionContraUsuario) = txtContrasenaServidorBD.Text then
      begin
        md.tcConsulta.Close;
        md.tcConsulta.SQL.Clear;
        md.tcConsulta.SQL.Add('UPDATE ' + txtTabla.Text +
            ' SET NOMBRECOMPLETO = :pNombre WHERE USUARIO = :pUsuario');
        md.tcConsulta.ParamByName('pUsuario').DataType := ftstring;
        md.tcConsulta.ParamByName('pUsuario').Value :=
            AnsiUpperCase (txtUsuarioServidorBD.Text);
        md.tcConsulta.ParamByName('pNombre').DataType := ftstring;
        md.tcConsulta.ParamByName('pNombre').Value := txtNombreCompleto.text;
        md.tcConsulta.ExecSQL;
        modificadoUsuario := false;
        modificadoContrasena := false;
        modificadoNombre := false;
        Result := True;
        Screen.Cursor := crDefault;        
        MessageDlg('El usuario ' + txtUsuarioServidorBD.Text +
            ' ya exista. Se ha actualizado correctamente.', mtInformation, [mbok], 0);
      end
      else
      begin
        modificadoUsuario := false;
        modificadoContrasena := false;
        modificadoNombre := false;
        Result := False;
        Screen.Cursor := crDefault;        
        MessageDlg('El usuario ' + txtUsuarioServidorBD.Text +
            ' ya existe pero las contraseas no coinciden (compruebe ' +
            'el bloqueo maysculas y vuelva a intentarlo.', mtError, [mbok], 0);
        txtContrasenaServidorBD.SetFocus;
      end;
    end
    else
    begin
      md.tcConsulta.Close;
      md.tcConsulta.SQL.Clear;
      if txtProtocolo.Text <> 'mysql-4.1' then
        md.tcConsulta.SQL.Add('INSERT INTO ' + txtTabla.Text +
            ' (USUARIO, CONTRASENA, FECHAALTA, NOMBRECOMPLETO) ' +
            'VALUES (:pUsuario, :pContrasena, :pFechaAlta, :pNombre)')
      else
        md.tcConsulta.SQL.Add('INSERT INTO ' + txtTabla.Text +
            ' (USUARIO, CONTRASENA, FECHAALTA, NOMBRECOMPLETO) ' +
            'VALUES (:pUsuario, :pContrasena, STR_TO_DATE(:pFechaAlta, "%d/%c/%Y %H:%i:%s"), :pNombre)');
      md.tcConsulta.ParamByName('pUsuario').DataType := ftstring;
      md.tcConsulta.ParamByName('pUsuario').Value := AnsiUpperCase (txtUsuarioServidorBD.Text);
      md.tcConsulta.ParamByName('pContrasena').DataType := ftstring;
      md.tcConsulta.ParamByName('pContrasena').Value :=
          encriptar (txtContrasenaServidorBD.Text, claveEncriptacionContraUsuario);
      if txtProtocolo.Text <> 'mysql-4.1' then
        md.tcConsulta.ParamByName('pFechaAlta').DataType := ftDateTime
      else
        md.tcConsulta.ParamByName('pFechaAlta').DataType := ftString;
      md.tcConsulta.ParamByName('pFechaAlta').Value := now;
      md.tcConsulta.ParamByName('pNombre').DataType := ftstring;
      md.tcConsulta.ParamByName('pNombre').Value := txtNombreCompleto.text;
      md.tcConsulta.ExecSQL;
      modificadoUsuario := false;
      modificadoContrasena := false;
      modificadoNombre := false;
      Result := True;
      Screen.Cursor := crDefault;      
      MessageDlg('El usuario ' + txtUsuarioServidorBD.Text +
          ' se ha guardado correctamente en la BD.', mtInformation, [mbok], 0);
    end;
  except
    Screen.Cursor := crDefault;
    raise;
  end;
end;

procedure TformConfiguracionClienteBD.bCancelarClick(Sender: TObject);
begin
  close;
end;

procedure TformConfiguracionClienteBD.bGuardarClick(Sender: TObject);
var
  seguir : boolean;
begin
  seguir := true;
  if modificadoUsuario or modificadoContrasena or modificadoNombre then
  begin
    if MessageDlg('Ha modificado los datos del usuario y no los ha guardado ' +
        'en la Base de Datos Desea hacerlo ahora?', mtConfirmation,
        [mbyes, mbno], 0) = mryes then
      seguir := guardarDatosBD;
  end;

  if seguir then
  begin
    with tinifile.create (changefileext(paramstr(0),'.ini')) do
    try
      WriteString('Cliente BD', 'Servidor', txtIPServidor.Text);
      WriteString('Cliente BD', 'Puerto', txtPuerto.Text);
      WriteString('Cliente BD', 'Usuario conexin', txtUsuario.Text);
      WriteString('Cliente BD', 'Contrasea conexin',
          encriptar (txtContrasena.Text, claveEncriptacion));
      WriteString('Cliente BD', 'BD', txtBD.Text);
      WriteString('Cliente BD', 'Tabla', txtTabla.Text);
      WriteString('Cliente BD', 'Usuario', txtUsuarioServidorBD.Text);
      WriteString('Cliente BD', 'Contrasea',
          encriptar (txtContrasenaServidorBD.Text, claveEncriptacion));
      WriteString('Cliente BD', 'Nombre usuario completo', txtNombreCompleto.Text);
      WriteString('Cliente BD', 'Protocolo', txtProtocolo.Text);            
    finally
      Free;
    end;
    close;
  end
  else
    txtUsuarioServidorBD.SetFocus;
end;

procedure TformConfiguracionClienteBD.FormCreate(Sender: TObject);
begin
  with tinifile.create (changefileext(paramstr(0),'.ini')) do
  try
    txtIPServidor.Text := readString('Cliente BD', 'Servidor', 'ajpdsoft.com');
    txtPuerto.Text := readString('Cliente BD', 'Puerto', '3306');
    txtUsuario.Text := readString('Cliente BD', 'Usuario conexin', 'bdavisoip');
    txtContrasena.Text :=
        desencriptar (readString('Cliente BD', 'Contrasea conexin', ''),
            claveEncriptacion);
    txtBD.Text := readString('Cliente BD', 'BD', '');
    txtTabla.Text := readString('Cliente BD', 'Tabla', 'ip');
    txtContrasenaServidorBD.Text :=
        desencriptar(readString('Cliente BD', 'Contrasea', ''),
        claveEncriptacion);
    txtUsuarioServidorBD.Text :=  readString('Cliente BD', 'Usuario', '');
    txtNombreCompleto.Text := readString('Cliente BD', 'Nombre usuario completo', '');
    txtProtocolo.Text := ReadString('Cliente BD', 'Protocolo', 'mysql-4.1');
  finally
    Free;
  end;
  modificadoUsuario := false;
  modificadoContrasena := false;
  modificadoNombre := false;
end;

procedure TformConfiguracionClienteBD.bProbarClick(Sender: TObject);
begin
  try
    Screen.Cursor := crHourGlass;
    md.tcConsulta.Active := false;
    md.BD.Connected := false;
    md.BD.LoginPrompt := false;
    md.bd.Protocol := txtProtocolo.Text;
    md.BD.HostName := txtIPServidor.Text;
    md.BD.Port := strtoint(txtPuerto.Text);
    md.BD.Database := txtBD.Text;
    md.BD.User := txtUsuario.Text;
    md.BD.Password := txtContrasena.Text;
    md.BD.Connected := true;
    Screen.Cursor := crDefault;
    MessageDlg('Conexin realizada correctamente con la Base de datos remota.',
        mtInformation, [mbok], 0);
    txtTabla.Items.Clear;
    txtTabla.Items.AddStrings(obtenerMySQLTablas);
  except
    Screen.Cursor := crDefault;  
    raise;
  end;
end;

procedure TformConfiguracionClienteBD.bGuardarUsuarioClick(
  Sender: TObject);
begin
  if (txtUsuarioServidorBD.Text <> '') and
      (txtContrasenaServidorBD.Text <> '') then
    guardarDatosBD
  else
  begin
    MessageDlg('Debe introducir el usuario y contrasea en el que se guardar la IP.',
       mtInformation, [mbok], 0);
    txtUsuarioServidorBD.SetFocus;
  end;
end;

procedure TformConfiguracionClienteBD.txtUsuarioServidorBDChange(
  Sender: TObject);
begin
  modificadoUsuario := true;
end;

procedure TformConfiguracionClienteBD.txtContrasenaServidorBDChange(
  Sender: TObject);
begin
  modificadoContrasena := true;
end;

procedure TformConfiguracionClienteBD.txtNombreCompletoChange(
  Sender: TObject);
begin
  modificadoNombre := true;
end;

procedure TformConfiguracionClienteBD.txtProtocoloChange(
  Sender: TObject);
begin
  if txtProtocolo.Text = 'mysql-4.1' then
    lInfoProtocolo.Caption := 'Necesitar la librera: libmysql41.dll';
  if txtProtocolo.Text = 'mysql-4.0' then
    lInfoProtocolo.Caption := 'Necesitar la librera: libmysql40.dll';
  if txtProtocolo.Text = 'mysql-3.23' then
    lInfoProtocolo.Caption := 'Necesitar la librera: libmysql323.dll';
  if txtProtocolo.Text = 'mysql-3.20' then
    lInfoProtocolo.Caption := 'Necesitar la librera: libmysql320.dll';
  if (txtProtocolo.Text <> 'mysql-4.1') and (txtProtocolo.Text <> 'mysql-4.0') and
      (txtProtocolo.Text <> 'mysql-3.23') and (txtProtocolo.Text <> 'mysql-3.20') then
    lInfoProtocolo.Caption := 'Protocolo desconocido';
end;

procedure TformConfiguracionClienteBD.txtNombreCompletoKeyPress(
  Sender: TObject; var Key: Char);
begin
  if (Key = #13) and (txtUsuarioServidorBD.Text <> '') then
    bGuardarUsuario.SetFocus;
end;

procedure TformConfiguracionClienteBD.bOpcionesClick(Sender: TObject);
begin
  //opciones avanzadas
  if not sb.Visible then
  begin
    sb.Visible := true;
    Height := 377;
  end
  else
  begin //modo normal
    sb.Visible := false;
    Height := 171;
  end;
end;

procedure TformConfiguracionClienteBD.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := cafree;
end;

end.
